(function(FuseBox){FuseBox.$fuse$=FuseBox;
FuseBox.target = "server";
FuseBox.pkg("default", {}, function(___scope___){
___scope___.file("index.js", function(exports, require, module, __filename, __dirname){

"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fuse_box_1 = require("fuse-box");
var yargs_1 = require("yargs");
var ng_compiler_plugin_1 = require("./tools/plugins/ng.compiler.plugin");
var ng_polyfill_plugin_1 = require("./tools/plugins/ng.polyfill.plugin");
var ng_prod_plugin_1 = require("./tools/plugins/ng.prod.plugin");
var ng_optimizer_plugin_1 = require("./tools/plugins/ng.optimizer.plugin");
var ng_server_module_plugin_1 = require("./tools/plugins/ng.server.module.plugin");
var ng_bootstrap_plugin_1 = require("./tools/plugins/ng.bootstrap.plugin");
var promises_1 = require("fs/promises");
var path_1 = require("path");
var DEFAULT_CONFIG = {
    enableAotCompilaton: yargs_1.argv.aot,
    productionBuild: yargs_1.argv.prod,
    supportIE11: true,
    supportIE11Animations: false,
    enableAngularAnimations: false,
    enableAngularForms: false,
    enableServiceWorker: false,
    serverPort: process.env.PORT && +process.env.PORT || 5000,
    angularServerModule: {
        moduleName: 'AppServerModule',
        modulePath: 'src/server/server.angular.module'
    }
};
var NG_CONTAINER;
(function (NG_CONTAINER) {
    NG_CONTAINER["SERVER"] = "src/server";
    NG_CONTAINER["BROWSER"] = "src/browser";
})(NG_CONTAINER || (NG_CONTAINER = {}));
var resolveNgFile = function (container, file) {
    console.log(container);
    // const containerPathPart = container === NG_CONTAINER.SERVER
    //   ? 'src/server'
    //   :
    var originPath = path_1.resolve('node_modules/src/server');
    var serverPath = path_1.resolve('src/server');
    var filePath = path_1.resolve(serverPath, file);
    return promises_1.lstat('filePath')
        .catch(function () { return promises_1.copyFile(path_1.resolve(originPath, file), filePath)
        .catch(function () {
        throw new Error('failed to load file');
    }); })
        .then(console.log);
};
var init = function () {
    resolveNgFile(NG_CONTAINER.SERVER, 'server.ts');
    // const basePath = resolve('src')
    // const originPath = resolve('node_modules/src/server')
    // const serverPath = resolve('src/server')
    // const filePath = resolve(serverPath, 'server.ts')
    // lstat('filePath')
    //   .catch(() => {
    //     return copyFile('node_modules/src/server/server.ts', filePath).catch(console.log)
    //   })
    //   .then(console.log)
};
function fusingAngular(opts) {
    init();
    var settings = __assign({}, DEFAULT_CONFIG, opts);
    var fuseBrowser = fuse_box_1.FuseBox.init({
        homeDir: "./",
        output: "./.dist/public/js/$name.js",
        target: 'browser@es5',
        cache: !settings.productionBuild,
        plugins: [
            ng_bootstrap_plugin_1.NgBootstrapPlugin({ enabled: settings.enableAotCompilaton }),
            ng_prod_plugin_1.NgProdPlugin({ enabled: settings.productionBuild }),
            ng_polyfill_plugin_1.NgPolyfillPlugin(),
            ng_compiler_plugin_1.NgCompilerPlugin({ enabled: settings.enableAotCompilaton }),
            ng_optimizer_plugin_1.NgOptimizerPlugin({ enabled: settings.enableAngularBuildOptimizer }),
            settings.productionBuild && fuse_box_1.QuantumPlugin({
                bakeApiIntoBundle: 'vendor',
                warnings: false,
                uglify: true,
                treeshake: true,
                ensureES5: true
            })
        ]
    });
    var fuseServer = fuse_box_1.FuseBox.init({
        target: 'server@es5',
        homeDir: "./",
        output: "./.dist/$name.js",
        cache: !settings.productionBuild,
        plugins: [
            fuse_box_1.EnvPlugin({ serverPort: settings.serverPort }),
            ng_prod_plugin_1.NgProdPlugin({ enabled: settings.productionBuild, fileTest: 'server.angular.module' }),
            settings.angularServerModule && ng_server_module_plugin_1.NgServerModulePlugin({
                module: settings.angularServerModule.moduleName,
                path: settings.angularServerModule.modulePath
            }),
            ng_polyfill_plugin_1.NgPolyfillPlugin({ isServer: true, fileTest: 'server.angular.module' })
        ]
    });
    var vendorBundle = fuseBrowser.bundle('vendor');
    var appBundle = fuseBrowser.bundle('app');
    var serverBundle = fuseServer.bundle("server");
    var browserBundlePath = settings.angularBrowserModulePath
        ? settings.angularBrowserModulePath
        : 'src/browser/app.browser.module.ts';
    var serverBundlePath = settings.expressServerPath
        ? settings.expressServerPath
        : '@node_modules/fusing-angular/src/server/server.ts';
    vendorBundle.instructions(" ~ " + browserBundlePath);
    appBundle.instructions(" !> [" + browserBundlePath + "]");
    serverBundle
        .instructions(" > [" + serverBundlePath + "]")
        .completed(function (proc) { return proc.start(); });
    if (!settings.productionBuild) {
        appBundle.watch('src/**');
        serverBundle.watch("src/**");
        fuseServer.dev({
            root: './.dist',
            port: settings.serverPort,
            httpServer: false
        });
    }
    fuseBrowser.run();
    fuseServer.run();
}
exports.fusingAngular = fusingAngular;
//# sourceMappingURL=index.js.map
});
___scope___.file("tools/plugins/ng.compiler.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var main_1 = require("@angular/compiler-cli/src/main");
var path_1 = require("path");
var defaults = {};
var NgcPluginClass = /** @class */ (function () {
    function NgcPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
    }
    NgcPluginClass.prototype.bundleStart = function () {
        this.opts.enabled && main_1.main(['-p', path_1.resolve('tsconfig.aot.json')]);
    };
    return NgcPluginClass;
}());
exports.NgcPluginClass = NgcPluginClass;
exports.NgCompilerPlugin = function (options) { return new NgcPluginClass(options); };
//# sourceMappingURL=ng.compiler.plugin.js.map
});
___scope___.file("tools/plugins/ng.polyfill.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaults = {};
exports.NG_POLY_BASE = [
    'core-js/es7/reflect'
];
exports.NG_POLY_SERVER = exports.NG_POLY_BASE.concat([
    'zone.js/dist/zone-node',
    'zone.js/dist/long-stack-trace-zone'
]);
exports.NG_POLY_BROWSER = exports.NG_POLY_BASE.concat([
    'zone.js/dist/zone'
]);
exports.NG_POLY_BROWSER_IE_ANIMATIONS = [
    'web-animations-js'
];
exports.NG_POLY_BROWSER_IE = [
    'core-js/es6/symbol',
    'core-js/es6/object',
    'core-js/es6/function',
    'core-js/es6/parse-int',
    'core-js/es6/parse-float',
    'core-js/es6/number',
    'core-js/es6/math',
    'core-js/es6/string',
    'core-js/es6/date',
    'core-js/es6/array',
    'core-js/es6/regexp',
    'core-js/es6/map',
    'core-js/es6/weak-map',
    'core-js/es6/set'
];
var prepForTransform = function (deps) {
    return deps.map(function (dep) {
        return "import '" + dep + "'";
    }).join('\n');
};
var NgPolyfillPluginClass = /** @class */ (function () {
    function NgPolyfillPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = this.opts.fileTest &&
            new RegExp(this.opts.fileTest) || /(app.browser.module.ts)/;
    }
    NgPolyfillPluginClass.prototype.onTypescriptTransform = function (file) {
        if (!this.test.test(file.relativePath))
            return;
        file.contents = prepForTransform(this.buildSet()) + "\n" + file.contents;
    };
    NgPolyfillPluginClass.prototype.buildSet = function () {
        if (this.opts.isServer) {
            return exports.NG_POLY_SERVER;
        }
        else {
            return exports.NG_POLY_BROWSER;
        }
    };
    return NgPolyfillPluginClass;
}());
exports.NgPolyfillPluginClass = NgPolyfillPluginClass;
exports.NgPolyfillPlugin = function (options) { return new NgPolyfillPluginClass(options); };
//# sourceMappingURL=ng.polyfill.plugin.js.map
});
___scope___.file("tools/plugins/ng.prod.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var defaults = {
    enabled: true
};
var NgProdPluginClass = /** @class */ (function () {
    function NgProdPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = this.regex || /(app.browser.module.ts)/;
        this.opts = __assign({}, defaults, opts);
    }
    Object.defineProperty(NgProdPluginClass.prototype, "regex", {
        get: function () {
            return this.opts &&
                this.opts.fileTest &&
                new RegExp(this.opts.fileTest) || undefined;
        },
        enumerable: true,
        configurable: true
    });
    NgProdPluginClass.prototype.onTypescriptTransform = function (file) {
        if (!this.opts.enabled || !this.test.test(file.relativePath))
            return;
        file.contents = "import { enableProdMode } from '@angular/core';\n    enableProdMode()\n    " + file.contents;
    };
    return NgProdPluginClass;
}());
exports.NgProdPluginClass = NgProdPluginClass;
exports.NgProdPlugin = function (options) { return new NgProdPluginClass(options); };
//# sourceMappingURL=ng.prod.plugin.js.map
});
___scope___.file("tools/plugins/ng.optimizer.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var build_optimizer_1 = require("@angular-devkit/build-optimizer");
var defaults = {};
var NgOptimizerPluginClass = /** @class */ (function () {
    function NgOptimizerPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = /.js/;
    }
    NgOptimizerPluginClass.prototype.transform = function (file) {
        if (!this.opts.enabled)
            return;
        var transpiledContent = build_optimizer_1.buildOptimizer({
            content: file.contents,
            isSideEffectFree: true
        }).content;
        if (transpiledContent) {
            file.contents = transpiledContent;
        }
    };
    return NgOptimizerPluginClass;
}());
exports.NgOptimizerPluginClass = NgOptimizerPluginClass;
exports.NgOptimizerPlugin = function (options) {
    return new NgOptimizerPluginClass(options);
};
//# sourceMappingURL=ng.optimizer.plugin.js.map
});
___scope___.file("tools/plugins/ng.server.module.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NgServerModulePluginClass = /** @class */ (function () {
    function NgServerModulePluginClass(opts) {
        this.opts = opts;
        this.test = /server.app.ts/;
    }
    NgServerModulePluginClass.prototype.onTypescriptTransform = function (file) {
        if (!file.relativePath.includes('server.app.ts'))
            return;
        var d = RegExp(/declare const AppServerModule: any/);
        var dotCountToAdd = file.relativePath.split('/').length - 1;
        var c = Array.from(Array(dotCountToAdd)).map(function (a) { return '..'; }).join('/');
        file.contents = file.contents.replace(d, "import { " + this.opts.module + " } from '" + c.concat('/') + this.opts.path + "'");
    };
    return NgServerModulePluginClass;
}());
exports.NgServerModulePluginClass = NgServerModulePluginClass;
exports.NgServerModulePlugin = function (options) {
    return new NgServerModulePluginClass(options);
};
//# sourceMappingURL=ng.server.module.plugin.js.map
});
___scope___.file("tools/plugins/ng.bootstrap.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaults = {};
var NgBootstrapPluginClass = /** @class */ (function () {
    function NgBootstrapPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = /app.browser.module.ts/;
    }
    NgBootstrapPluginClass.prototype.onTypescriptTransform = function (file) {
        if (this.opts.enabled && this.test.test(file.absPath) && file.context.bundle.name === 'app') {
            file.contents = file.contents.replace(/^.*platformBrowserDynamic.*/gm, '');
            file.contents =
                "\n        import { platformBrowser } from '@angular/platform-browser'\n        import { AppModuleNgFactory } from './.aot/src/browser/app.module.ngfactory.js'\n        platformBrowser().bootstrapModuleFactory(AppModuleNgFactory)\n        " + file.contents;
        }
    };
    return NgBootstrapPluginClass;
}());
exports.NgBootstrapPluginClass = NgBootstrapPluginClass;
exports.NgBootstrapPlugin = function (options) {
    return new NgBootstrapPluginClass(options);
};
//# sourceMappingURL=ng.bootstrap.plugin.js.map
});
return ___scope___.entry = ".build/index.js";
});
FuseBox.expose([{"alias":"*","pkg":"default/index.js"}]);
FuseBox.main("default/index.js");
})
(function(e){function r(e){var r=e.charCodeAt(0),n=e.charCodeAt(1);if((m||58!==n)&&(r>=97&&r<=122||64===r)){if(64===r){var t=e.split("/"),i=t.splice(2,t.length).join("/");return[t[0]+"/"+t[1],i||void 0]}var o=e.indexOf("/");if(o===-1)return[e];var a=e.substring(0,o),u=e.substring(o+1);return[a,u]}}function n(e){return e.substring(0,e.lastIndexOf("/"))||"./"}function t(){for(var e=[],r=0;r<arguments.length;r++)e[r]=arguments[r];for(var n=[],t=0,i=arguments.length;t<i;t++)n=n.concat(arguments[t].split("/"));for(var o=[],t=0,i=n.length;t<i;t++){var a=n[t];a&&"."!==a&&(".."===a?o.pop():o.push(a))}return""===n[0]&&o.unshift(""),o.join("/")||(o.length?"/":".")}function i(e){var r=e.match(/\.(\w{1,})$/);return r&&r[1]?e:e+".js"}function o(e){if(m){var r,n=document,t=n.getElementsByTagName("head")[0];/\.css$/.test(e)?(r=n.createElement("link"),r.rel="stylesheet",r.type="text/css",r.href=e):(r=n.createElement("script"),r.type="text/javascript",r.src=e,r.async=!0),t.insertBefore(r,t.firstChild)}}function a(e,r){for(var n in e)e.hasOwnProperty(n)&&r(n,e[n])}function u(e){return{server:require(e)}}function f(e,n){var o=n.path||"./",a=n.pkg||"default",f=r(e);if(f&&(o="./",a=f[0],n.v&&n.v[a]&&(a=a+"@"+n.v[a]),e=f[1]),e)if(126===e.charCodeAt(0))e=e.slice(2,e.length),o="./";else if(!m&&(47===e.charCodeAt(0)||58===e.charCodeAt(1)))return u(e);var s=x[a];if(!s){if(m&&"electron"!==y.target)throw"Package not found "+a;return u(a+(e?"/"+e:""))}e=e?e:"./"+s.s.entry;var l,d=t(o,e),c=i(d),p=s.f[c];return!p&&c.indexOf("*")>-1&&(l=c),p||l||(c=t(d,"/","index.js"),p=s.f[c],p||"."!==d||(c=s.s&&s.s.entry||"index.js",p=s.f[c]),p||(c=d+".js",p=s.f[c]),p||(p=s.f[d+".jsx"]),p||(c=d+"/index.jsx",p=s.f[c])),{file:p,wildcard:l,pkgName:a,versions:s.v,filePath:d,validPath:c}}function s(e,r,n){if(void 0===n&&(n={}),!m)return r(/\.(js|json)$/.test(e)?g.require(e):"");if(n&&n.ajaxed===e)return console.error(e,"does not provide a module");var i=new XMLHttpRequest;i.onreadystatechange=function(){if(4==i.readyState)if(200==i.status){var n=i.getResponseHeader("Content-Type"),o=i.responseText;/json/.test(n)?o="module.exports = "+o:/javascript/.test(n)||(o="module.exports = "+JSON.stringify(o));var a=t("./",e);y.dynamic(a,o),r(y.import(e,{ajaxed:e}))}else console.error(e,"not found on request"),r(void 0)},i.open("GET",e,!0),i.send()}function l(e,r){var n=_[e];if(n)for(var t in n){var i=n[t].apply(null,r);if(i===!1)return!1}}function d(e){return null!==e&&["function","object","array"].indexOf(typeof e)>-1&&void 0===e.default?Object.isFrozen(e)?e.default=e:Object.defineProperty(e,"default",{value:e,writable:!0,enumerable:!1}):void 0}function c(e,r){if(void 0===r&&(r={}),58===e.charCodeAt(4)||58===e.charCodeAt(5))return o(e);var t=f(e,r);if(t.server)return t.server;var i=t.file;if(t.wildcard){var a=new RegExp(t.wildcard.replace(/\*/g,"@").replace(/[.?*+^$[\]\\(){}|-]/g,"\\$&").replace(/@@/g,".*").replace(/@/g,"[a-z0-9$_-]+"),"i"),u=x[t.pkgName];if(u){var p={};for(var v in u.f)a.test(v)&&(p[v]=c(t.pkgName+"/"+v));return p}}if(!i){var h="function"==typeof r,_=l("async",[e,r]);if(_===!1)return;return s(e,function(e){return h?r(e):null},r)}var w=t.pkgName;if(i.locals&&i.locals.module)return i.locals.module.exports;var b=i.locals={},j=n(t.validPath);b.exports={},b.module={exports:b.exports},b.require=function(e,r){var n=c(e,{pkg:w,path:j,v:t.versions});return y.sdep&&d(n),n},m||!g.require.main?b.require.main={filename:"./",paths:[]}:b.require.main=g.require.main;var k=[b.module.exports,b.require,b.module,t.validPath,j,w];return l("before-import",k),i.fn.apply(k[0],k),l("after-import",k),b.module.exports}if(e.FuseBox)return e.FuseBox;var p="undefined"!=typeof ServiceWorkerGlobalScope,v="undefined"!=typeof WorkerGlobalScope,m="undefined"!=typeof window&&"undefined"!=typeof window.navigator||v||p,g=m?v||p?{}:window:global;m&&(g.global=v||p?{}:window),e=m&&"undefined"==typeof __fbx__dnm__?e:module.exports;var h=m?v||p?{}:window.__fsbx__=window.__fsbx__||{}:g.$fsbx=g.$fsbx||{};m||(g.require=require);var x=h.p=h.p||{},_=h.e=h.e||{},y=function(){function r(){}return r.global=function(e,r){return void 0===r?g[e]:void(g[e]=r)},r.import=function(e,r){return c(e,r)},r.on=function(e,r){_[e]=_[e]||[],_[e].push(r)},r.exists=function(e){try{var r=f(e,{});return void 0!==r.file}catch(e){return!1}},r.remove=function(e){var r=f(e,{}),n=x[r.pkgName];n&&n.f[r.validPath]&&delete n.f[r.validPath]},r.main=function(e){return this.mainFile=e,r.import(e,{})},r.expose=function(r){var n=function(n){var t=r[n].alias,i=c(r[n].pkg);"*"===t?a(i,function(r,n){return e[r]=n}):"object"==typeof t?a(t,function(r,n){return e[n]=i[r]}):e[t]=i};for(var t in r)n(t)},r.dynamic=function(r,n,t){this.pkg(t&&t.pkg||"default",{},function(t){t.file(r,function(r,t,i,o,a){var u=new Function("__fbx__dnm__","exports","require","module","__filename","__dirname","__root__",n);u(!0,r,t,i,o,a,e)})})},r.flush=function(e){var r=x.default;for(var n in r.f)e&&!e(n)||delete r.f[n].locals},r.pkg=function(e,r,n){if(x[e])return n(x[e].s);var t=x[e]={};return t.f={},t.v=r,t.s={file:function(e,r){return t.f[e]={fn:r}}},n(t.s)},r.addPlugin=function(e){this.plugins.push(e)},r.packages=x,r.isBrowser=m,r.isServer=!m,r.plugins=[],r}();return m||(g.FuseBox=y),e.FuseBox=y}(this))